import 'dart:collection';

import 'package:objd/basic/condition.dart';
import 'package:objd/basic/entity.dart';
import 'package:objd/basic/for_list.dart';
import 'package:objd/basic/score.dart';
import 'package:objd/basic/scoreboard.dart';
import 'package:objd/basic/widget.dart';

class Delay {
	static const String Name = "dabric_delay";

	static final HashMap<int, Score> _delays = HashMap();

	static Widget init() {
		addDelay(2);
		addDelay(5);
		addDelay(10);
		addDelay(20);

		return For.of([
			Scoreboard(Name, addIntoLoad: false),
			Score(Entity.PlayerName('timer'), Name, addNew: false).set(0),
			..._delays.values
		]);
	}

	static Widget tick() {
		return For.of([
			Score(Entity.PlayerName('timer'), Name, addNew: false).add(1)
		]);
	}

	static void addDelay(int ticks) {
		_delays.addEntries([
			MapEntry(ticks, Score(Entity.PlayerName('#${ticks}'), Name, addNew: false).set(ticks))
		]);
	}

	static Condition ticks(int ticks) {
		return Condition.score(Score(Entity.PlayerName('timer'), Name, addNew: false).modulo(_delays[ticks]));
	}
}
